# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           apache-openjpa
Version:        2.2.0
Release:        1%{?dist}
Epoch:          0
Summary:        Apache OpenJPA implementation of JSR-317 JPA 2.0
License:        Apache Software License 2.0
Url:            http://openjpa.apache.org/
Group:          Development/Libraries
Source0:        apache-openjpa-2.2.0.tgz
# svn export http://svn.apache.org/repos/asf/openjpa/tags/2.2.0/ apache-openjpa-2.2.0 && tar czf apache-openjpa-2.2.0.tgz apache-openjpa-2.2.0

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

Patch0:         apache-openjpa-pom.patch
Patch1:         apache-openjpa-project-pom.patch
Patch2:         apache-openjpa-maven-plugin-pom.patch
Patch3:         apache-openjpa-examples-simple-pom.patch
Patch4:         apache-openjpa-examples-openbooks-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-checkstyle
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-shade
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-bundle-plugin
BuildRequires:  maven-plugin-testing-harness
BuildRequires:  maven-release
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-report-plugin
BuildRequires:  maven-surefire-provider-junit3
BuildRequires:  mojo-ianal-maven-plugin
BuildRequires:  mojo-maven2-plugin-buildnumber
BuildRequires:  mojo-maven2-plugin-findbugs
BuildRequires:  mojo-maven2-plugin-javacc
BuildRequires:  mojo-maven2-plugin-taglist
BuildRequires:  ant-jsch
BuildRequires:  ant-contrib
BuildRequires:  apache-commons-dbcp
BuildRequires:  apache-rat
BuildRequires:  derby
BuildRequires:  docbkx
BuildRequires:  findbugs
BuildRequires:  hsqldb
BuildRequires:  jmock2
BuildRequires:  junit
BuildRequires:  mysql-connector-java
BuildRequires:  postgresql-jdbc
BuildRequires:  regexp
BuildRequires:  simple-jndi

BuildRequires:  ant
BuildRequires:  antlr3
BuildRequires:  apache-bval
BuildRequires:  apache-commons-parent
BuildRequires:  apache-commons-beanutils
BuildRequires:  apache-commons-collections
BuildRequires:  apache-commons-jci-compiler-rhino
BuildRequires:  apache-commons-lang
BuildRequires:  apache-commons-logging
BuildRequires:  apache-commons-pool
BuildRequires:  de-java2html
BuildRequires:  geronimo-genesis
BuildRequires:  geronimo-genesis2
BuildRequires:  geronimo-jms-1.1-api
BuildRequires:  geronimo-jpa-2.0-api
BuildRequires:  geronimo-jta-1.1-api
BuildRequires:  geronimo-validation-1.0-api
BuildRequires:  log4j
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  objectweb-asm
BuildRequires:  org.osgi.core
BuildRequires:  plexus-utils
BuildRequires:  serp
BuildRequires:  slf4j
BuildRequires:  sun-jaxb-2.1-api
BuildRequires:  sun-jaxb-2.1-impl


Requires:  ant
Requires:  antlr3
Requires:  apache-bval
Requires:  apache-commons-parent
Requires:  apache-commons-beanutils
Requires:  apache-commons-collections
Requires:  apache-commons-jci-compiler-rhino
Requires:  apache-commons-lang
Requires:  apache-commons-logging
Requires:  apache-commons-pool
Requires:  de-java2html
Requires:  geronimo-jms-1.1-api
Requires:  geronimo-jpa-2.0-api
Requires:  geronimo-jta-1.1-api
Requires:  geronimo-validation-1.0-api
Requires:  log4j
Requires:  maven2 >= 0:2.0.8
Requires:  objectweb-asm
Requires:  org.osgi.core
Requires:  plexus-utils
Requires:  serp
Requires:  slf4j
Requires:  sun-jaxb-2.1-api
Requires:  sun-jaxb-2.1-impl


BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5


%description
Apache OpenJPA is a Java persistence project at The Apache 
Software Foundation that can be used as a stand-alone POJO 
persistence layer or integrated into any Java EE compliant 
container and many other lightweight frameworks, such as 
Tomcat and Spring.
The 2.x releases are a production ready, compliant 
implementation of the JSR-317 Java Persistence 2.0 
specification, which is backwards compatible to the 
JPA 1.0 specification and passes the Sun JPA 2.0 
Technology Compatibility Kit.


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q 

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
rm openjpa-persistence-jdbc/src/test/java/org/apache/openjpa/persistence/enhance/DynamicEnhancementSuite.java


%build

cp %{SOURCE1} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

mkdir -p m2_repo/repository/JPP/openjpa/

ln -s $(build-classpath maven2/empty-dep) m2_repo/repository/JPP/openjpa/persistence-jdbc-tests.jar

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.test.skip=true \
        -Dsurefire.excludes.locking=** \
        install 
#       -Dmaven.test.failure.ignore=true \
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        javadoc:aggregate
pushd openjpa-examples
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install 
popd


%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom
%add_to_maven_depmap org.apache.openjpa openjpa-parent %{version} JPP/%{name} parent

install -m 644 openjpa-project/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-project.pom
%add_to_maven_depmap org.apache.openjpa apache-openjpa %{version} JPP/%{name} project

install -m 644 openjpa-all/target/openjpa-all-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/all-%{version}.jar
install -m 644 openjpa-all/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-all.pom
%add_to_maven_depmap org.apache.openjpa openjpa-all %{version} JPP/%{name} all

install -m 644 openjpa-examples/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-examples.pom
%add_to_maven_depmap org.apache.openjpa openjpa-examples %{version} JPP/%{name} examples

install -m 644 openjpa-examples/image-gallery/target/image-gallery-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/image-gallery-%{version}.jar
install -m 644 openjpa-examples/image-gallery/target/image-gallery-%{version}-tests.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/image-gallery-tests-%{version}.jar
install -m 644 openjpa-examples/image-gallery/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-image-gallery.pom
%add_to_maven_depmap org.apache.openjpa.openjpa-examples image-gallery %{version} JPP/%{name} image-gallery

install -m 644 openjpa-examples/openbooks/target/openbooks-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/openbooks-%{version}.jar
install -m 644 openjpa-examples/openbooks/target/openbooks-%{version}-tests.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/openbooks-tests-%{version}.jar
install -m 644 openjpa-examples/openbooks/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-openbooks.pom
%add_to_maven_depmap org.apache.openjpa.openjpa-examples openbooks %{version} JPP/%{name} openbooks

install -m 644 openjpa-examples/simple/target/simple-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/simple-%{version}.jar
install -m 644 openjpa-examples/simple/target/simple-%{version}-tests.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/simple-tests-%{version}.jar
install -m 644 openjpa-examples/simple/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-simple.pom
%add_to_maven_depmap org.apache.openjpa.openjpa-examples simple %{version} JPP/%{name} simple

install -m 644 openjpa-integration/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-integration.pom
%add_to_maven_depmap org.apache.openjpa openjpa-integration %{version} JPP/%{name} integration

install -m 644 openjpa-integration/daytrader/target/openjpa-integration-daytrader-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-daytrader-%{version}.jar
install -m 644 openjpa-integration/daytrader/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-integration-daytrader.pom
%add_to_maven_depmap org.apache.openjpa.openjpa openjpa-integration-daytrader %{version} JPP/%{name} integration-daytrader

install -m 644 openjpa-integration/jmx/target/openjpa-integration-jmx-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-jmx-%{version}.jar
install -m 644 openjpa-integration/jmx/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-integration-jmx.pom
%add_to_maven_depmap org.apache.openjpa.openjpa openjpa-integration-jmx %{version} JPP/%{name} integration-jmx

install -m 644 openjpa-integration/slf4j/target/openjpa-integration-slf4j-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-slf4j-%{version}.jar
install -m 644 openjpa-integration/slf4j/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-integration-slf4j.pom
%add_to_maven_depmap org.apache.openjpa.openjpa openjpa-integration-slf4j %{version} JPP/%{name} integration-slf4j

install -m 644 openjpa-integration/validation/target/openjpa-integration-validation-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-validation-%{version}.jar
install -m 644 openjpa-integration/validation/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-integration-validation.pom
%add_to_maven_depmap org.apache.openjpa.openjpa openjpa-integration-validation %{version} JPP/%{name} integration-validation

install -m 644 openjpa-jdbc/target/openjpa-jdbc-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jdbc-%{version}.jar
install -m 644 openjpa-jdbc/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jdbc.pom
%add_to_maven_depmap org.apache.openjpa openjpa-jdbc %{version} JPP/%{name} jdbc

install -m 644 openjpa-jest/target/openjpa-jest-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jest-%{version}.jar
install -m 644 openjpa-jest/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jest.pom
%add_to_maven_depmap org.apache.openjpa openjpa-jest %{version} JPP/%{name} jest

install -m 644 openjpa-kernel/target/openjpa-kernel-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/kernel-%{version}.jar
install -m 644 openjpa-kernel/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-kernel.pom
%add_to_maven_depmap org.apache.openjpa openjpa-kernel %{version} JPP/%{name} kernel

install -m 644 openjpa-lib/target/openjpa-lib-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/lib-%{version}.jar
install -m 644 openjpa-lib/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-lib.pom
%add_to_maven_depmap org.apache.openjpa openjpa-lib %{version} JPP/%{name} lib

install -m 644 openjpa-persistence/target/openjpa-persistence-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/persistence-%{version}.jar
install -m 644 openjpa-persistence/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-persistence.pom
%add_to_maven_depmap org.apache.openjpa openjpa-persistence %{version} JPP/%{name} persistence

install -m 644 openjpa-persistence-jdbc/target/openjpa-persistence-jdbc-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/persistence-jdbc-%{version}.jar
install -m 644 openjpa-persistence-jdbc/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-persistence-jdbc.pom
%add_to_maven_depmap org.apache.openjpa openjpa-persistence-jdbc %{version} JPP/%{name} persistence-jdbc

install -m 644 openjpa-persistence-locking/target/openjpa-persistence-locking-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/persistence-locking-%{version}.jar
install -m 644 openjpa-persistence-locking/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-persistence-locking.pom
%add_to_maven_depmap org.apache.openjpa openjpa-persistence-locking %{version} JPP/%{name} persistence-locking

install -m 644 openjpa-slice/target/openjpa-slice-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/slice-%{version}.jar
install -m 644 openjpa-slice/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-slice.pom
%add_to_maven_depmap org.apache.openjpa openjpa-slice %{version} JPP/%{name} slice

install -m 644 openjpa/target/openjpa-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/openjpa-%{version}.jar
install -m 644 openjpa/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-openjpa.pom
%add_to_maven_depmap org.apache.openjpa openjpa %{version} JPP/%{name} openjpa

install -m 644 openjpa-tools/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-tools.pom
%add_to_maven_depmap org.apache.openjpa openjpa-tools %{version} JPP/%{name} tools

install -m 644 openjpa-tools/openjpa-maven-plugin/target/openjpa-maven-plugin-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/maven-plugin-%{version}.jar
install -m 644 openjpa-tools/openjpa-maven-plugin/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-plugin.pom
%add_to_maven_depmap org.apache.openjpa openjpa-maven-plugin %{version} JPP/%{name} maven-plugin

install -m 644 openjpa-xmlstore/target/openjpa-xmlstore-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/xmlstore-%{version}.jar
install -m 644 openjpa-xmlstore/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-xmlstore.pom
%add_to_maven_depmap org.apache.openjpa openjpa-xmlstore %{version} JPP/%{name} xmlstore

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* \
    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/site/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
#cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap


%files 
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Thu Jun 28 2012 Ralph Apel <r.apel at r-apel.de> 0:2.2.0-1
- 2.2.0 for JPP-6

